/*
 * Some code borrowed from Disable Targets for Downloads by Ben Basson (Cusser)
 */

var linkWatch = 
{
	loaded: null,

	init: function () {
		if (linkWatch.loaded)
			return; 
		linkWatch.loaded = true;
		getBrowser().addEventListener("mousedown", linkWatch.mousedown, true);
	},
  
	mousedown: function (aEvent)
	{
		if (!aEvent)
			return;
		if (aEvent.target)
			var targ = aEvent.originalTarget;

		var prefs = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);
		if (prefs.getPrefType("extensions.sfdirectdl.mirrorName") != prefs.PREF_STRING)
			return;
		var mirror = prefs.getCharPref("extensions.sfdirectdl.mirrorName");
		if (!mirror)
			return;

		if (targ.tagName.toUpperCase() != "A") {
			// Recurse until reaching root node
			while (targ.parentNode) {
				targ = targ.parentNode;
				// stop if an anchor is located
				if (targ.tagName && targ.tagName.toUpperCase() == "A")
					break;
			}
			if (!targ.tagName || targ.tagName.toUpperCase() != "A")
				return;
		}

		var linkHref = targ.getAttribute("href");
		var linkPrefix = "http://prdownloads.sourceforge.net/";

		if (linkHref.substring(0, linkPrefix.length) == linkPrefix) {
			linkHref = linkHref.substring(linkPrefix.length);
			var i = linkHref.indexOf('?');
			if (i != -1)
				linkHref = linkHref.substring(0, i);

			targ.setAttribute("href", "http://" + mirror + ".dl.sourceforge.net/sourceforge/" + linkHref);
		}
	}
  
}

window.addEventListener("load", linkWatch.init, false);  
